

/* [Dimensiones] */

// Diámetro del vaso
Dia_Vaso = 70;

// Diámetro del tubo de la silla en X
Dia_TuboX =33;

// Diámetro del tubo de la silla en Y
Dia_TuboY =26.5;

// Ángulo de rotación de su tubo con respecto a la vertical (0 si está perpendicular al suelo)
Angulo = 0;


/* [General] */

Mostrar = "Sujeta";    //[ Mordaza:Mordaza para fijar a la silla, Sujeta:Sujeta vasos]

// Suavizado
Suavizado = 40;



module Cola_Milano_M(Ancho_1=20, Ancho_2=12, Profundidad=4, Altura=30) {
linear_extrude(height= Altura)
polygon( points=[[-Ancho_1/2,-Profundidad],[Ancho_1/2,-Profundidad],[Ancho_2/2,0],[-Ancho_2/2,0]] );
}


module Cola_Milano_H(Ancho_1=20, Ancho_2=12, Profundidad=4, Altura=30, Holgura=0.2, Grosor_Tope=3, Grosor_Pared_Ancho=3, Grosor_Pared_Prof=2) {
translate([0,-(Profundidad+Grosor_Pared_Prof)/2,-(Altura+Grosor_Tope)/2])difference() {
    translate([0,(Grosor_Pared_Prof+Profundidad)/2,Altura/2+Grosor_Tope/2]) cube([Ancho_1+Grosor_Pared_Ancho*2,Profundidad+Grosor_Pared_Prof,Altura+Grosor_Tope],center=true);

        linear_extrude(height= Altura)
            polygon( points=[[-Ancho_1/2-Holgura,Grosor_Pared_Prof],[Ancho_1/2+Holgura,Grosor_Pared_Prof],[Ancho_2/2+Holgura,Profundidad+Grosor_Pared_Prof],[-Ancho_2/2-Holgura,Profundidad+Grosor_Pared_Prof]] );
}
}


module Tuerca_M3() {
    cylinder(d=6.1,h=4,center=true,$fn=6);
    cylinder(d=3.4,h= 20,center=true,$fn=Suavizado);
}


module Tornillo_M3() {
    cylinder(d=6.2,h=3.2,$fn=Suavizado);
    translate([0,0,3.1999]) cylinder(d=3.4,h= 12,$fn=Suavizado);
}

module Tuerca_M5() {
    cylinder(d=8.8,h=4,center=true,$fn=6);
    cylinder(d=5.3,h= 20,center=true,$fn=Suavizado);
}


module Tornillo_M5() {
    cylinder(d=8.6,h=5,$fn=Suavizado);
    translate([0,0,4.9999]) cylinder(d=3.4,h= 12,$fn=Suavizado);
}


module Cuadroide(D_I=70,D_Grosor=6,alto=7,Curva=3,Angulo=360,Suave=80) {
    translate([0,0,-alto/2])rotate_extrude(angle=Angulo,$fn=Suave)
        translate([D_I/2, Curva/2])
            square([D_Grosor,alto-Curva],$fn=Suave);
    translate([0,0,-alto/2])rotate_extrude(angle=Angulo,$fn=Suave)
        translate([D_I/2+Curva/2, 0])
            square([D_Grosor-Curva,alto],$fn=Suave);
    translate([0,0,-alto/2+Curva/2])rotate_extrude(angle=Angulo,$fn=Suave)
        translate([D_I/2+Curva/2, 0])
            circle(d=Curva,$fn=Suave);
    translate([0,0,alto/2-Curva/2])rotate_extrude(angle=Angulo,$fn=Suave)
        translate([D_I/2+Curva/2, 0])
            circle(d=Curva,$fn=Suave);
    translate([0,0,-alto/2+Curva/2])rotate_extrude(angle=Angulo,$fn=Suave)
        translate([D_I/2+D_Grosor-Curva/2, 0])
            circle(d=Curva,$fn=Suave);
    translate([0,0,alto/2-Curva/2])rotate_extrude(angle=Angulo,$fn=Suave)
        translate([D_I/2+D_Grosor-Curva/2, 0])
            circle(d=Curva,$fn=Suave);
}

module Sujeta() {
// Cilindro interior
difference() {
    Cuadroide(D_I=Dia_Vaso,D_Grosor=6,alto=8,Curva=2,Angulo=360,Suave=Suavizado);
        translate([0,Dia_Vaso/2+1.6,0]) rotate([90,0,0]) Tuerca_M3();
        translate([0,-Dia_Vaso/2-1.6,0]) rotate([90,0,0]) Tuerca_M3();
}

// Cilindro intermedio
difference() {
    Cuadroide(D_I=Dia_Vaso+14,D_Grosor=6,alto=8,Curva=2,Angulo=360,Suave=Suavizado);
        translate([0,Dia_Vaso/2+14-1,0]) rotate([90,0,0]) Tornillo_M3();
        translate([0,-Dia_Vaso/2-14+1,0]) rotate([-90,0,0]) Tornillo_M3();
        translate([-Dia_Vaso/2-14/2-1.7,0,0]) rotate([90,0,90]) Tuerca_M3();
        translate([Dia_Vaso/2+14/2+1.7,0,0]) rotate([90,0,90]) Tuerca_M3();
}

// Cilindro exterior
difference() {
    union() {
    rotate([0,0,-8]) Cuadroide(D_I=Dia_Vaso+14+14,D_Grosor=6,alto=8,Curva=2,Angulo=196,Suave=Suavizado);
    translate([0,Dia_Vaso/2+14+9,0]) cube([10,10,8],center=true);
    translate([0,Dia_Vaso/2+14+14,-4]) rotate([0,0,180]) Cola_Milano_M(16,10,4,17);
    }
        *translate([0,Dia_Vaso/2+14-0.2,0]) rotate([-90,0,0]) Tornillo_M3();
        *translate([0,Dia_Vaso/2+14+9,-2]) cube([5.5,2,9.5],center=true);
        translate([-Dia_Vaso/2-14-6,0,0]) rotate([90,0,90]) Tornillo_M3();
        translate([Dia_Vaso/2+14+6,0,0]) rotate([90,0,-90]) Tornillo_M3();
}
}



module Mordaza() {
difference() {
union() {
resize([Dia_TuboX+5,Dia_TuboY+5,0]) cylinder(d=Dia_TuboX,h=20,center=true,$fn=Suavizado);
    translate([6,0,0]) cube([Dia_TuboX+12,16,20],center=true);
}
    resize([Dia_TuboX,Dia_TuboY,0]) cylinder(d=Dia_TuboX,h=30,center=true,$fn=Suavizado);
    translate([-Dia_TuboX/2-4,0,0]) cube([10,Dia_TuboY+12,25],center=true);
    translate([0,0,0]) cube([Dia_TuboX+50,1,25],center=true);
    *translate([-(Dia_TuboX+20)/2+5,-4.01,0]) rotate([90,30,0]) Tuerca_M5();
    *translate([-(Dia_TuboX+20)/2+5,6.01,0]) rotate([90,30,0]) Tornillo_M5();
    translate([(Dia_TuboX+21)/2-5,6.01,0]) rotate([90,30,0]) Tuerca_M5();
    translate([(Dia_TuboX+21)/2-5,-8.01,0]) rotate([-90,0,0]) Tornillo_M5();
}

translate([0,-Dia_TuboY/2-3.5,0]) rotate([0,180+Angulo,180]) Cola_Milano_H(Ancho_1=16, Ancho_2=10, Profundidad=4, Altura=17, Holgura=0.2, Grosor_Tope=3, Grosor_Pared_Ancho=2, Grosor_Pared_Prof=2);
}


if (Mostrar=="Sujeta") {
    Sujeta();
}

if (Mostrar=="Mordaza") {
    Mordaza();
}





